Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.functions
Class IntegratedFunctionLibrary

    java.lang.Object
      net.sf.saxon.functions.IntegratedFunctionLibrary

All Implemented Interfaces:
  Serializable, FunctionLibrary

Direct Known Subclasses:
  VendorFunctionLibrary

    public class IntegratedFunctionLibrary

extends Object
implements FunctionLibrary, Serializable

A library of integrated function calls, that is, user-written extension functions implemented as instances of the class IntegratedFunction.

See Also:
  Serialized Form

Constructor Summary
`IntegratedFunctionLibrary()`

Method Summary
`Expression` | `bind(StructuredQName functionName, Expression[] staticArgs, StaticContext env, Container container)` Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
`FunctionLibrary` | `copy()` This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
`SequenceType[]` | `getFunctionSignature(StructuredQName functionName, int arity)` Test whether a system function with a given name and arity is available, and return its signature.
`Iterator<StructuredQName>` | `iterateFunctionNames()` Return an iterator over the names of the functions registered in this library
`void` | `registerFunction(ExtensionFunctionDefinition function)` Register an integrated function with this function library

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### IntegratedFunctionLibrary

    public IntegratedFunctionLibrary()

Method Detail

### registerFunction

    public void registerFunction(ExtensionFunctionDefinition function)

  Register an integrated function with this function library

  Parameters:
    `function` - the implementation of the function (or set of functions)

### getFunctionSignature

    public SequenceType[] getFunctionSignature(StructuredQName functionName,
                                               int arity)

  Test whether a system function with a given name and arity is available, and return its signature. This supports the function-available() function in XSLT. This method may be called either at compile time or at run time.

  Specified by:
    `getFunctionSignature` in interface `FunctionLibrary`
  Parameters:
    `functionName` - the name of the function
    `arity` - The number of arguments. This is set to -1 in the case of the single-argument
  Returns:
    if a function of this name and arity is available for calling, then the type signature of the function, as an array of sequence types in which the zeroth entry represents the return type; or a zero-length array if the function exists but the signature is not known; or null if the function does not exist

### bind

    public Expression bind(StructuredQName functionName,
                           Expression[] staticArgs,
                           StaticContext env,
                           Container container)
                    throws XPathException

  Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.

  Specified by:
    `bind` in interface `FunctionLibrary`
  Parameters:
    `functionName` - the QName of the function being called
    `staticArgs` - The expressions supplied statically in arguments to the function call. The length of this array represents the arity of the function. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality()) may be used as part of the binding algorithm. In some cases it may be possible for the function to be pre-evaluated at compile time, for example if these expressions are all constant values.

    The conventions of the XPath language demand that the results of a function depend only on the values of the expressions supplied as arguments, and not on the form of those expressions. For example, the result of f(4) is expected to be the same as f(2+2). The actual expression is supplied here to enable the binding mechanism to select the most efficient possible implementation (including compile-time pre-evaluation where appropriate).
    `env` - The static context of the function call
    `container` -
  Returns:
    An object representing the function to be called, if one is found; null if no function was found matching the required name and arity.
  Throws:
    `XPathException` - if a function is found with the required name and arity, but the implementation of the function cannot be loaded or used; or if an error occurs while searching for the function.

### copy

    public FunctionLibrary copy()

  This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.

  Specified by:
    `copy` in interface `FunctionLibrary`
  Returns:
    a copy of this function library. This must be an instance of the original class.

### iterateFunctionNames

    public Iterator<StructuredQName> iterateFunctionNames()

  Return an iterator over the names of the functions registered in this library

  Returns:
    an iterator over the function names

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.